﻿Imports UniversalTicket
Public Class Form1
    Private iWelcomePort As Integer = 77
    Private sServerPW As String = "holz-ist-cool-33"
    Private uts As New UTicketServer(iWelcomePort, 88, sServerPW)
    Private WithEvents utc_master As New UTicketClient("127.0.0.1", iWelcomePort, sServerPW, Me)
    Private bClosing As Boolean = False
    Private uRegistrierteUserList As New List(Of User)
    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        uts.shutdown()
    End Sub
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        uts.start()
        utc_master.start("@master")
    End Sub
    Private Sub utc_master_ConnectionNotPossible(sReason As String) Handles utc_master.ConnectionNotPossible
        set_status_problem()
        MsgBox(sReason & vbNewLine & vbNewLine & "Please start again!", MsgBoxStyle.Exclamation)
    End Sub
    Private Sub masterVerbunden() Handles utc_master.ConnectionReadyForSending
        set_status_ok()
    End Sub
    Private Sub set_status_ok()
        picStatus.BackColor = Color.Green
        info("Simple Messenger Master ist bereit!")
    End Sub
    Private Sub set_status_problem()
        picStatus.BackColor = Color.Red
    End Sub
    Private Sub utc_master_IDisGone(sID As String) Handles utc_master.IDisGone
        For Each u In uRegistrierteUserList
            If u.getUT_ID = sID Then
                u.setOffline()
                verteileListeDerOnlineUser()
                info("Logout: " & u.getUsername & " ist offline")
                Exit For
            End If
        Next
    End Sub
    Private Sub utc_master_UTicketArrived(sSenderID As String, bSentToAll As Boolean, sCommand As String, oUserData As List(Of Object)) Handles utc_master.UTicketArrived
        Select Case sCommand
            Case "registriere"
                utc_master.sendUTicket(sSenderID, "registrierungs_ergebnis", neuenUserAnlegen(oUserData(0).ToString, oUserData(1).ToString))
            Case "login"
                utc_master.sendUTicket(sSenderID, "login_ergebnis", login(sSenderID, oUserData(0).ToString, oUserData(1).ToString))
            Case "nachricht_weiterleiten"
                nachrichtWeiterleiten(getUserByUT_ID(sSenderID), getUser(oUserData(0).ToString), oUserData(1).ToString)
        End Select
    End Sub
    Private Sub nachrichtWeiterleiten(ByRef uSender As User, ByRef uEmpfaenger As User, ByVal sText As String)
        If uEmpfaenger IsNot Nothing And uSender IsNot Nothing Then
            info("Sende Nachricht von " & uSender.getUsername & " an " & uEmpfaenger.getUsername)
            Dim oDatenZumSenden As New List(Of Object)
            oDatenZumSenden.Add(My.Computer.Clock.LocalTime)
            oDatenZumSenden.Add(uSender.getUsername)
            oDatenZumSenden.Add(sText)
            utc_master.sendUTicket(uEmpfaenger.getUT_ID, "nachricht_anzeigen", oDatenZumSenden)
        End If
    End Sub
    Private Function getUserByUT_ID(ByVal sUT_ID As String) As User
        Dim us As User = Nothing
        For Each u In uRegistrierteUserList
            If u.getUT_ID = sUT_ID Then
                us = u
                Exit For
            End If
        Next
        Return us
    End Function
    Private Function getUser(ByVal sUsername As String) As User
        Dim us As User = Nothing
        For Each u In uRegistrierteUserList
            If u.getUsername = sUsername Then
                us = u
                Exit For
            End If
        Next
        Return us
    End Function
    Private Function login(ByVal sUT_ID As String, ByVal sUsername As String, ByVal sPWhash As String) As String
        Dim sErgebnis As String
        Dim us As User = Nothing
        Dim bUsernameExistiert As Boolean = False
        For Each u In uRegistrierteUserList
            If u.getUsername = sUsername Then
                us = u
                bUsernameExistiert = True
                Exit For
            End If
        Next
        If bUsernameExistiert = True Then
            If us.isBanned Then
                info("Verbannter User " & sUsername & " wollte sich einloggen ...")
                sErgebnis = "Sie sind leider vom Server verbannt worden!"
            Else
                If us.checkePasswort(sPWhash) Then
                    us.setOnline(sUT_ID)
                    verteileListeDerOnlineUser()
                    info("Login: " & sUsername)
                    sErgebnis = "login_erfolgreich"
                Else
                    info("User " & sUsername & " hat ein falsches Passwort eingegeben ...")
                    sErgebnis = "Das angegebene Passwort war leider falsch!"
                End If
            End If
        Else
            info("Jemand wollte sich mit " & sUsername & " einloggen ...")
            sErgebnis = "Dieser Benutzername existiert leider nicht!"
        End If
        Return sErgebnis
    End Function
    Private Function neuenUserAnlegen(ByVal sUsername As String, ByVal sPWhash As String) As String
        Dim sErgebnis As String
        Dim bUsernameSchonVerwendet As Boolean = False
        For Each u In uRegistrierteUserList
            If u.getUsername = sUsername Then
                bUsernameSchonVerwendet = True
                Exit For
            End If
        Next
        If bUsernameSchonVerwendet Then
            info("Registriereung Fehlerschlag: " & sUsername & " bereits vergeben!")
            sErgebnis = "Benutzername ist leider schon vergeben!"
        Else
            uRegistrierteUserList.Add(New User(sUsername, sPWhash))
            info("Neuer User wurde registriert: " & sUsername)
            sErgebnis = "registrierung_erfolgreich"
        End If
        Return sErgebnis
    End Function
    Private Sub info(ByVal sText As String)
        lstInfo.Items.Add(sText)
        lstInfo.SelectedIndex = lstInfo.Items.Count - 1
    End Sub
    Private Sub verteileListeDerOnlineUser()
        Dim oUsernamen As New List(Of Object)
        For Each u In uRegistrierteUserList
            If u.isOnline = True Then
                oUsernamen.Add(u.getUsername)
            End If
        Next
        utc_master.sendUTicket("@all", "neue_liste_der_online_user", oUsernamen)
    End Sub
End Class
